DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Tiling Algorithms

Layout algorithms determine the position and size of tiles and groups. In this demo, you can use the drop-down menu below the component to apply different algorithms.

www.wikipedia.org
Backend API
$(() => { const algorithms = ['sliceAndDice', 'squarified', 'strip', 'custom']; let currentAlgorithm = algorithms[2]; const treeMap = $('#treemap').dxTreeMap({ dataSource: populationByAge, layoutAlgorithm: currentAlgorithm, colorizer: { type: 'discrete', colorizeGroups: true, }, title: 'Population by Age Groups', tooltip: { enabled: true, format: 'thousands', customizeTooltip(arg) { const { data } = arg.node; const parentData = arg.node.getParent().data; let result = ''; if (arg.node.isLeaf()) { result = `<span class='country'>${parentData.name}</span><br />${ data.name}<br />${arg.valueText} (${ ((100 * data.value) / parentData.total).toFixed(1)}%)`; } else { result = `<span class='country'>${data.name}</span>`; } return { text: result, }; }, }, }).dxTreeMap('instance'); $('#algorithm').dxSelectBox({ items: algorithms, width: 200, inputAttr: { 'aria-label': 'Algorithm' }, value: currentAlgorithm, onValueChanged(data) { if (data.value === 'custom') { currentAlgorithm = customAlgorithm; } else { currentAlgorithm = data.value; } treeMap.option('layoutAlgorithm', currentAlgorithm); }, }); function customAlgorithm(arg) { let side = 0; const totalRect = arg.rect.slice(); let totalSum = arg.sum; arg.items.forEach((item) => { const size = Math.round(((totalRect[side + 2] - totalRect[side]) * item.value) / totalSum); const rect = totalRect.slice(); totalSum -= item.value; totalRect[side] += size; rect[side + 2] = totalRect[side]; item.rect = rect; side = 1 - side; }); } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="treemap"></div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Tiling Algorithm</span> <div id="algorithm" class="selectbox"></div> </div> </div> </div> </body> </html>
#treemap { height: 460px; } .country { font-weight: 500; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } .option { margin-top: 10px; } .caption { font-size: 18px; font-weight: 500; } .option > span { margin-right: 10px; } .option > .dx-widget { display: inline-block; vertical-align: middle; }
const populationByAge = [{ name: 'Brazil', total: 200050486, items: [{ name: 'Age 0-14', value: 48058462, }, { name: 'Age 15-44', value: 96036995, }, { name: 'Age 45-64', value: 40715296, }, { name: 'Age 65+', value: 15239733, }], }, { name: 'Japan', total: 126345237, items: [{ name: 'Age 0-14', value: 16593766, }, { name: 'Age 15-44', value: 45455276, }, { name: 'Age 45-64', value: 32845790, }, { name: 'Age 65+', value: 31450405, }], }, { name: 'United States', total: 318497627, items: [{ name: 'Age 0-14', value: 63968935, }, { name: 'Age 15-44', value: 127217843, }, { name: 'Age 45-64', value: 83145484, }, { name: 'Age 65+', value: 44165365, }], }];

The TreeMap component supports three layout algorithms out of the box:

  • Squarified (default)
    This algorithm lays the items out so that the aspect ratio will be closer to 1. In other words, this algorithm tries to make items as square as possible.

  • Strip
    This algorithm is a modification of the "Squarified" algorithm. At the beginning, the algorithm has an available area divided into several strips and a set of items to distribute between the strips. Throughout the layout process, the current strip is maintained. For each item to be arranged, the algorithm checks whether or not adding the item to the current strip improves the average aspect ratios of the rectangles in the current strip. If so, the item is added to the current strip. Otherwise, it is added to the next strip.

  • Slice and Dice
    This algorithm uses parallel lines to divide an available area into rectangles that visualize items. In a hierarchical structure, each rectangle that visualizes an item is further divided into smaller rectangles that visualize its children, and so on.

Use the layoutAlgorithm property to specify the tile layout. You can also implement your own algorithm. For this purpose, assign a function to the layoutAlgorithm property. This function calculates the coordinates of two diagonally-opposing points that define a rectangle and assigns them to the required item.

<dx-tree-map
id="treemap"
[dataSource]="getPopulationsByAge"
title="Population by Age Groups"
[layoutAlgorithm]="
selectbox.value === 'custom' ? customAlgorithm : selectbox.value
"
>
<dxo-tree-map-colorizer
type="discrete"
[colorizeGroups]="true"
></dxo-tree-map-colorizer>
<dxo-tree-map-tooltip
[enabled]="true"
format="thousands"
[customizeTooltip]="customizeTooltip"
></dxo-tree-map-tooltip>
</dx-tree-map>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Tiling Algorithm</span>
<dx-select-box
#selectbox
[items]="algorithms"
[inputAttr]="{ 'aria-label': 'Algorithm' }"
[width]="200"
[value]="algorithms[2]"
>
</dx-select-box>
</div>
</div>
import { ChangeDetectionStrategy, Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { DxTreeMapModule, DxSelectBoxModule } from 'devextreme-angular';
import { PopulationByAge, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
changeDetection: ChangeDetectionStrategy.Eager,
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxTreeMapModule,
DxSelectBoxModule,
],
})
export class AppComponent {
getPopulationsByAge: PopulationByAge[];
algorithms = ['sliceAndDice', 'squarified', 'strip', 'custom'];
constructor(service: Service) {
this.getPopulationsByAge = service.getPopulationsByAge();
}
customizeTooltip(arg) {
const data = arg.node.data;
const parentData = arg.node.getParent().data;
let result: string;
if (arg.node.isLeaf()) {
result = `<span class='country'>${parentData.name}</span><br />${
data.name}<br />${arg.valueText} (${
(100 * data.value / parentData.total).toFixed(1)}%)`;
} else {
result = `<span class='country'>${data.name}</span>`;
}
return {
text: result,
};
}
customAlgorithm(arg) {
let side = 0;
const totalRect = arg.rect.slice();
let totalSum = arg.sum;
arg.items.forEach((item) => {
const size = Math.round((totalRect[side + 2] - totalRect[side]) * item.value / totalSum);
const rect = totalRect.slice();
totalSum -= item.value;
const adjustedSize = totalRect[side] + size;
totalRect[side] = adjustedSize;
rect[side + 2] = adjustedSize;
item.rect = rect;
side = 1 - side;
});
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #treemap {
height: 460px;
}
::ng-deep .country {
font-weight: 500;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
margin-right: 10px;
}
::ng-deep .option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export interface PopulationByAge {
name: string;
total: number;
items: Record<string, unknown>[];
}
const populationsByAge: PopulationByAge[] = [{
name: 'Brazil',
total: 200050486,
items: [{
name: 'Age 0-14',
value: 48058462,
}, {
name: 'Age 15-44',
value: 96036995,
}, {
name: 'Age 45-64',
value: 40715296,
}, {
name: 'Age 65+',
value: 15239733,
}],
}, {
name: 'Japan',
total: 126345237,
items: [{
name: 'Age 0-14',
value: 16593766,
}, {
name: 'Age 15-44',
value: 45455276,
}, {
name: 'Age 45-64',
value: 32845790,
}, {
name: 'Age 65+',
value: 31450405,
}],
}, {
name: 'United States',
total: 318497627,
items: [{
name: 'Age 0-14',
value: 63968935,
}, {
name: 'Age 15-44',
value: 127217843,
}, {
name: 'Age 45-64',
value: 83145484,
}, {
name: 'Age 65+',
value: 44165365,
}],
}];
@Injectable()
export class Service {
getPopulationsByAge() {
return populationsByAge;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Charts - Tiling Algorithms

Layout algorithms determine the position and size of tiles and groups. In this demo, you can use the drop-down menu below the component to apply different algorithms.

www.wikipedia.org
Backend API
import React, { useCallback, useState } from 'react'; import TreeMap, { Colorizer, Tooltip, } from 'devextreme-react/tree-map'; import type { ITreeMapOptions, ITooltipProps } from 'devextreme-react/tree-map'; import type { TreeMapLayoutAlgorithm } from 'devextreme/viz/tree_map'; import SelectBox, { type SelectBoxTypes } from 'devextreme-react/select-box'; import { populationByAge, algorithmLabel } from './data.ts'; const algorithms: (TreeMapLayoutAlgorithm | 'custom')[] = ['sliceanddice', 'squarified', 'strip', 'custom']; function App() { const [selectedAlgorithm, setSelectedAlgorithm] = useState(algorithms[2]); const [ currentAlgorithm, setCurrentAlgorithm, ] = useState<ITreeMapOptions['layoutAlgorithm']>(getCurrentAlgorithm(algorithms[2])); const setAlgorithm = useCallback((data: SelectBoxTypes.ValueChangedEvent) => { setSelectedAlgorithm(data.value); setCurrentAlgorithm(() => getCurrentAlgorithm(data.value)); }, [setSelectedAlgorithm, setCurrentAlgorithm]); return ( <> <TreeMap id="treemap" dataSource={populationByAge} layoutAlgorithm={currentAlgorithm} title="Population by Age Groups" > <Colorizer colorizeGroups={true} type="discrete" /> <Tooltip enabled={true} customizeTooltip={customizeTooltip} format="thousands" /> </TreeMap> <div className="options"> <div className="caption">Options</div> <div className="option"> <span>Tiling Algorithm </span> <SelectBox dataSource={algorithms} width={200} inputAttr={algorithmLabel} value={selectedAlgorithm} onValueChanged={setAlgorithm} /> </div> </div> </> ); } const customAlgorithm: ITreeMapOptions['layoutAlgorithm'] = (arg): void => { const totalRect = arg.rect?.slice(); let totalSum = arg.sum ?? 0; let side = 0; if (!totalRect || totalSum <= 0) { return; } arg.items?.forEach((item): void => { const size = Math.round(((totalRect[side + 2] - totalRect[side]) * item.value) / totalSum); const rect = totalRect.slice(); totalSum -= item.value; totalRect[side] += size; rect[side + 2] = totalRect[side]; item.rect = rect; side = 1 - side; }); }; function getCurrentAlgorithm(selectedAlgorithm: (TreeMapLayoutAlgorithm | 'custom')): ITreeMapOptions['layoutAlgorithm'] { let currentAlgorithm: ITreeMapOptions['layoutAlgorithm'] | 'custom' = selectedAlgorithm; if (currentAlgorithm === 'custom') { currentAlgorithm = customAlgorithm; } return currentAlgorithm; } const customizeTooltip: ITooltipProps['customizeTooltip'] = (arg) => { const { data } = arg.node; const parentData = arg.node.getParent().data; return { text: arg.node.isLeaf() ? `<span class='country'>${parentData.name}</span><br />${data.name}<br />${arg.valueText}(${((100 * data.value) / parentData.total).toFixed(1)}%)` : `<span class='country'>${data.name}</span>`, }; }; export default App;
import React, { useCallback, useState } from 'react'; import TreeMap, { Colorizer, Tooltip } from 'devextreme-react/tree-map'; import SelectBox from 'devextreme-react/select-box'; import { populationByAge, algorithmLabel } from './data.js'; const algorithms = ['sliceanddice', 'squarified', 'strip', 'custom']; function App() { const [selectedAlgorithm, setSelectedAlgorithm] = useState(algorithms[2]); const [currentAlgorithm, setCurrentAlgorithm] = useState(getCurrentAlgorithm(algorithms[2])); const setAlgorithm = useCallback( (data) => { setSelectedAlgorithm(data.value); setCurrentAlgorithm(() => getCurrentAlgorithm(data.value)); }, [setSelectedAlgorithm, setCurrentAlgorithm], ); return ( <> <TreeMap id="treemap" dataSource={populationByAge} layoutAlgorithm={currentAlgorithm} title="Population by Age Groups" > <Colorizer colorizeGroups={true} type="discrete" /> <Tooltip enabled={true} customizeTooltip={customizeTooltip} format="thousands" /> </TreeMap> <div className="options"> <div className="caption">Options</div> <div className="option"> <span>Tiling Algorithm </span> <SelectBox dataSource={algorithms} width={200} inputAttr={algorithmLabel} value={selectedAlgorithm} onValueChanged={setAlgorithm} /> </div> </div> </> ); } const customAlgorithm = (arg) => { const totalRect = arg.rect?.slice(); let totalSum = arg.sum ?? 0; let side = 0; if (!totalRect || totalSum <= 0) { return; } arg.items?.forEach((item) => { const size = Math.round(((totalRect[side + 2] - totalRect[side]) * item.value) / totalSum); const rect = totalRect.slice(); totalSum -= item.value; totalRect[side] += size; rect[side + 2] = totalRect[side]; item.rect = rect; side = 1 - side; }); }; function getCurrentAlgorithm(selectedAlgorithm) { let currentAlgorithm = selectedAlgorithm; if (currentAlgorithm === 'custom') { currentAlgorithm = customAlgorithm; } return currentAlgorithm; } const customizeTooltip = (arg) => { const { data } = arg.node; const parentData = arg.node.getParent().data; return { text: arg.node.isLeaf() ? `<span class='country'>${parentData.name}</span><br />${data.name}<br />${arg.valueText}(${( (100 * data.value) / parentData.total ).toFixed(1)}%)` : `<span class='country'>${data.name}</span>`, }; }; export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
export const populationByAge = [{ name: 'Brazil', total: 200050486, items: [{ name: 'Age 0-14', value: 48058462, }, { name: 'Age 15-44', value: 96036995, }, { name: 'Age 45-64', value: 40715296, }, { name: 'Age 65+', value: 15239733, }], }, { name: 'Japan', total: 126345237, items: [{ name: 'Age 0-14', value: 16593766, }, { name: 'Age 15-44', value: 45455276, }, { name: 'Age 45-64', value: 32845790, }, { name: 'Age 65+', value: 31450405, }], }, { name: 'United States', total: 318497627, items: [{ name: 'Age 0-14', value: 63968935, }, { name: 'Age 15-44', value: 127217843, }, { name: 'Age 45-64', value: 83145484, }, { name: 'Age 65+', value: 44165365, }], }]; export const algorithmLabel = { 'aria-label': 'Algorithm' };
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.ts': { loader: 'demo-ts-loader', }, '*.tsx': { loader: 'demo-ts-loader', typescriptOptions: { jsx: 'react', }, }, 'typescript': { 'exports': 'ts', }, 'anti-forgery': { loader: 'demo-ts-loader', }, 'react': { 'esModule': true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', 'loaders:': '../../../../shared/loaders/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'demo-ts-loader': 'loaders:demo-ts-loader.js', 'demo-ts-shared': 'loaders:demo-ts-shared.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
export const populationByAge = [ { name: 'Brazil', total: 200050486, items: [ { name: 'Age 0-14', value: 48058462, }, { name: 'Age 15-44', value: 96036995, }, { name: 'Age 45-64', value: 40715296, }, { name: 'Age 65+', value: 15239733, }, ], }, { name: 'Japan', total: 126345237, items: [ { name: 'Age 0-14', value: 16593766, }, { name: 'Age 15-44', value: 45455276, }, { name: 'Age 45-64', value: 32845790, }, { name: 'Age 65+', value: 31450405, }, ], }, { name: 'United States', total: 318497627, items: [ { name: 'Age 0-14', value: 63968935, }, { name: 'Age 15-44', value: 127217843, }, { name: 'Age 45-64', value: 83145484, }, { name: 'Age 65+', value: 44165365, }, ], }, ]; export const algorithmLabel = { 'aria-label': 'Algorithm' };
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#treemap { height: 460px; } .country { font-weight: 500; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } .option { margin-top: 10px; } .caption { font-size: 18px; font-weight: 500; } .option > span { margin-right: 10px; } .option > .dx-widget { display: inline-block; vertical-align: middle; }

The TreeMap component supports three layout algorithms out of the box:

  • Squarified (default)
    This algorithm lays the items out so that the aspect ratio will be closer to 1. In other words, this algorithm tries to make items as square as possible.

  • Strip
    This algorithm is a modification of the "Squarified" algorithm. At the beginning, the algorithm has an available area divided into several strips and a set of items to distribute between the strips. Throughout the layout process, the current strip is maintained. For each item to be arranged, the algorithm checks whether or not adding the item to the current strip improves the average aspect ratios of the rectangles in the current strip. If so, the item is added to the current strip. Otherwise, it is added to the next strip.

  • Slice and Dice
    This algorithm uses parallel lines to divide an available area into rectangles that visualize items. In a hierarchical structure, each rectangle that visualizes an item is further divided into smaller rectangles that visualize its children, and so on.

Use the layoutAlgorithm property to specify the tile layout. You can also implement your own algorithm. For this purpose, assign a function to the layoutAlgorithm property. This function calculates the coordinates of two diagonally-opposing points that define a rectangle and assigns them to the required item.

<template>
<div>
<DxTreeMap
id="treemap"
:data-source="populationByAge"
:layout-algorithm="currentAlgorithm"
title="Population by Age Groups"
>
<DxColorizer
:colorize-groups="true"
type="discrete"
/>
<DxTooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
format="thousands"
/>
</DxTreeMap>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Tiling Algorithm</span>
<DxSelectBox
:data-source="algorithms"
:input-attr="{ 'aria-label': 'Algorithm' }"
:width="200"
v-model:value="selectedAlgorithm"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import DxTreeMap,
{
DxColorizer,
DxTooltip,
type DxTreeMapTypes,
} from 'devextreme-vue/tree-map';
import { DxSelectBox } from 'devextreme-vue/select-box';
import { populationByAge } from './data.ts';
type CustomAlgorithm = (e: { items: any[]; rect: number[]; sum: number; }) => void;
type SelectedAlgorithm = DxTreeMapTypes.TreeMapLayoutAlgorithm | 'custom';
const algorithms: SelectedAlgorithm[] = ['sliceanddice', 'squarified', 'strip', 'custom'];
const selectedAlgorithm = ref(algorithms[2]);
const currentAlgorithm = computed(() => (
(selectedAlgorithm.value === 'custom')
? customAlgorithm
: selectedAlgorithm.value),
);
const customAlgorithm: CustomAlgorithm = ({ rect, sum, items }) => {
const totalRect = rect.slice();
let totalSum = sum;
let side = 0;
items.forEach((item) => {
const size = Math.round(((totalRect[side + 2] - totalRect[side]) * item.value) / totalSum);
const itemRect = totalRect.slice();
totalSum -= item.value;
totalRect[side] += size;
itemRect[side + 2] = totalRect[side];
item.rect = itemRect;
side = 1 - side;
});
};
function customizeTooltip({
node, node: { data: { name, value } }, valueText,
}: Record<string, any>) {
const parentData = node.getParent().data;
return {
text: node.isLeaf()
? `<span class='country'>${parentData.name}</span><br />${name}<br />${valueText}(${((100 * value) / parentData.total).toFixed(1)}%)`
: `<span class='country'>${name}</span>`,
};
}
</script>
<style scoped>
#treemap {
height: 460px;
}
.country {
font-weight: 500;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
margin-right: 14px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const populationByAge = [{
name: 'Brazil',
total: 200050486,
items: [{
name: 'Age 0-14',
value: 48058462,
}, {
name: 'Age 15-44',
value: 96036995,
}, {
name: 'Age 45-64',
value: 40715296,
}, {
name: 'Age 65+',
value: 15239733,
}],
}, {
name: 'Japan',
total: 126345237,
items: [{
name: 'Age 0-14',
value: 16593766,
}, {
name: 'Age 15-44',
value: 45455276,
}, {
name: 'Age 45-64',
value: 32845790,
}, {
name: 'Age 65+',
value: 31450405,
}],
}, {
name: 'United States',
total: 318497627,
items: [{
name: 'Age 0-14',
value: 63968935,
}, {
name: 'Age 15-44',
value: 127217843,
}, {
name: 'Age 45-64',
value: 83145484,
}, {
name: 'Age 65+',
value: 44165365,
}],
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>